package net.rmi.pawelGrid.LusCs;

import gui.JInfoFrame;
import net.multicast.McastUtil;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.InetAddress;
import java.net.Socket;


public class LusRcvr extends Thread {
    private McastUtil mcu;
    public JInfoFrame jif;
    public InetAddress lusIp;
    public InetAddress ip;
    public static String IP = null;
    public String mfloops = null;
    private CsRecords csRecords;
    private CsRecordFrame crf = new CsRecordFrame();


    public LusRcvr(McastUtil mcu, JInfoFrame jif, CsRecords csRecords) {
        this.jif = jif;
        this.mcu = mcu;
        this.csRecords = csRecords;
        start();                // start calls run
    }

    public void run() {
        try {
            while (true) {
                processBytes();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void processBytes() throws IOException {

        BenchMarkBean bmb = BenchMarkBean.restore(mcu.getBytes());
        ip = mcu.getReceiveAddress();
        lusIp = mcu.getSendAddress();
        CsRecord csr = new CsRecord();
        csr.setBmb(bmb);
        csr.setIpAddress(ip);
        csRecords.add(csr);
        jif.println(csr + "");
        connectToCS(csr.getIpAddress());
        crf.addPanel(csr);
       
    }


    public InetAddress getSendAddress() {
        return mcu.getSendAddress();
    }

    public String getLusIp() throws IOException {
        System.out.println(
                "from lus my ip " +
                InetAddress.getLocalHost().getHostAddress().toString());
        return InetAddress.getLocalHost().getHostAddress().toString();
    }

    public void connectToCS(InetAddress ip) {
        try {
            Socket socket = new Socket(ip, 1200);
            System.out.println("socked opened");
            BufferedWriter wr = new BufferedWriter(
                    new OutputStreamWriter(socket.getOutputStream()));
            wr.write(getLusIp());
            wr.flush();
            socket.close();

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

